## nifticlib 3.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

set(NIFTI_MAX_VALIDATED_CMAKE_VERSION "3.13.1")
if("${CMAKE_VERSION}" VERSION_LESS_EQUAL "${NIFTI_MAX_VALIDATED_CMAKE_VERSION}")
  # As of 2018-12-04 NIFTI has been validated to build with cmake version 3.13.1 new policies.
  # Set and use the newest cmake policies that are validated to work
  set(NIFTI_CMAKE_POLICY_VERSION "${CMAKE_VERSION}")
else()
  set(NIFTI_CMAKE_POLICY_VERSION "${NIFTI_MAX_VALIDATED_CMAKE_VERSION}")
endif()
cmake_policy(VERSION ${NIFTI_CMAKE_POLICY_VERSION})

set(NIFTI_HOMEPAGE_URL "https://nifti-imaging.github.io")
execute_process(COMMAND git "describe" "--tags"
  OUTPUT_VARIABLE GIT_REPO_VERSION_UNCLEANED
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

#Extract the GIT_REPO_VERSION as composed of non-negative integer components,
# i.e. <major>[.<minor>[.<patch>[.<tweak>]]]
string(REGEX MATCH "[0-9]+\\.[0-9]+\\.[0-9]+((beta.*)?(alpha.*)?\\.[0-9]+(\\.g[0-9a-f]+)?)?"
 GIT_REPO_VERSION  "${GIT_REPO_VERSION_UNCLEANED}")

if( NOT GIT_REPO_VERSION )
  message(NOTE "Invalid git tag does not match required regular expression, "
               "can not extract version information from '${GIT_REPO_VERSION_UNCLEANED}'")
  # NOTE: cmake -DGIT_REPO_VERSION:STRING=<major>[.<minor>[.<patch>[.<tweak>]]] can be used
  #       to set the repo string for non-git repos.
  set(GIT_REPO_VERSION "0.0.0.0") #Manually set the version string for testing purposes
endif()
project(NIFTI
        VERSION ${GIT_REPO_VERSION}
        DESCRIPTION "Niftilib is a set of i/o libraries for reading and writing files in the nifti-1 data format. nifti-1 is a binary file format for storing medical image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI) brain images."
        LANGUAGES C)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)
include(nifti_macros)

set_property(GLOBAL PROPERTY nifti_installed_targets)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)
include(CMakeDependentOption)

if("${CMAKE_VERSION}" VERSION_GREATER_EQUAL "3.13")
set(CMAKE_VER_AT_LEAST_3_13 1 CACHE BOOL "Is set for cmake >=3.13")
endif()

# add option to build shared libraries. The default is OFF to maintain the
# current build behavior
option( BUILD_SHARED_LIBS "Toggle building shared libraries." OFF)

# Include executables as part of the build
option(NIFTI_BUILD_APPLICATIONS "Build various utility tools" ON)
mark_as_advanced(NIFTI_BUILD_APPLICATIONS)

#When including nifti as a subpackage, a prefix is often needed to avoid conflicts with sytem installed libraries.
set_if_not_defined(NIFTI_PACKAGE_PREFIX "")
set(PACKAGE_NAME ${NIFTI_PACKAGE_PREFIX}NIFTI)
set_if_not_defined(NIFTI_INSTALL_EXPORT_NAME ${PACKAGE_NAME}Targets)

# Set default shared library version
# This library version will be applied to all libraries in the package
# unless it is not explicitely for a certain lib.
set(NIFTI_SHAREDLIB_VERSION ${GIT_REPO_VERSION} )
if(BUILD_SHARED_LIBS AND NOT NIFTI_LIBRARY_PROPERTIES)
  set(NIFTI_LIBRARY_PROPERTIES ${DEFAULT_SHARED_LIBS}
    BUILD_SHARED_LIBS TRUE POSITION_INDEPENDENT_CODE TRUE
  )
endif()

set_if_not_defined(NIFTI_INSTALL_RUNTIME_DIR bin)
set_if_not_defined(NIFTI_INSTALL_LIBRARY_DIR lib)
set_if_not_defined(NIFTI_INSTALL_ARCHIVE_DIR ${NIFTI_INSTALL_LIBRARY_DIR})
set_if_not_defined(NIFTI_INSTALL_INCLUDE_DIR include/nifti)
set_if_not_defined(NIFTI_INSTALL_MAN_DIR share/man/man1)
set_if_not_defined(NIFTI_INSTALL_DOC_DIR share/doc/${PROJECT_NAME})
set_if_not_defined(NIFTI_ZLIB_LIBRARIES "")
set_if_not_defined(ZNZ_COMPILE_DEF "")
if(NOT NIFTI_ZLIB_LIBRARIES) # If using a custom zlib library, skip the find package
  ###  USE AS STAND ALONE PACKAGE
  find_package(ZLIB REQUIRED)
  set(NIFTI_ZLIB_LIBRARIES ${ZLIB_LIBRARIES})
endif()
#message(STATUS "---------------------ZLIB -${NIFTI_ZLIB_LIBRARIES}--")
add_definitions(-DHAVE_ZLIB)

set_if_not_defined(NIFTI_INSTALL_NO_DOCS TRUE)

# Include test to verify linking in installed executables
# The test should only be added when applications are built, and no prefix string is set.
cmake_dependent_option(
  TEST_INSTALL "Add a test to check that linking to SO libraries occurs correctly during installation." ON
  "${NIFTI_PACKAGE_PREFIX};${NIFTI_BUILD_APPLICATIONS};${BUILD_SHARED_LIBS};${NIFTI_BUILD_TESTING}" OFF
)

# Add a default attempt at setting the run path correctly for binaries
if(NOT CMAKE_SKIP_INSTALL_RPATH)
  file(
    RELATIVE_PATH
    relDir
    ${CMAKE_INSTALL_PREFIX}/${NIFTI_INSTALL_RUNTIME_DIR}
    ${CMAKE_INSTALL_PREFIX}/${NIFTI_INSTALL_LIBRARY_DIR}
  )
  if(APPLE)
    set_if_not_defined(CMAKE_INSTALL_RPATH  "@loader_path/${relDir}")
  else()
    set_if_not_defined(CMAKE_INSTALL_RPATH   "\$ORIGIN/${relDir}")
  endif()
endif()

if(NOT NIFTI_INSTALL_NO_DOCS)
      find_program(HELP2MAN help2man REQUIRED)
      set(MAN_DIR ${PROJECT_BINARY_DIR}/manpages)
      file(MAKE_DIRECTORY ${MAN_DIR})
endif()
#######################################################################

set_if_not_defined(BUILD_TESTING ON)
set_if_not_defined(NIFTI_BUILD_TESTING ${BUILD_TESTING})
if (NIFTI_BUILD_TESTING )
  include(CTest)
  enable_testing()
  #Needs an if clause and more work before testing can take place.
  option(
    DOWNLOAD_TEST_DATA
    "Allow download of data used for some tests. Can be used in conjunction with ctest label filter '-LE NEEDS_DATA'"
    ON
    )
  set_if_not_defined(NIFTI_SHELL_SCRIPT_TESTS "ON")
  if(DOWNLOAD_TEST_DATA)
  if ( CMAKE_VERSION VERSION_LESS 3.11.0 )
    # CMAKE VERSION 3.11.0 needed for fetching data with cmake
    message(FATAL_ERROR "ERROR:  The testing framework for nifti_clib requires CMake version 3.11.0 or greater")
  endif()

  include(FetchContent) # fetch data a configure time to simplify tests
  # If new or changed data is needed, add that data to the https://github.com/NIFTI-Imaging/nifti-test-data repo
  # make a new release, and then update the URL and hash (shasum -a 256 <downloaded tarball>).
  FetchContent_Declare( fetch_testing_data
          URL      https://github.com/NIFTI-Imaging/nifti-test-data/archive/v3.0.2.tar.gz
          URL_HASH SHA256=5dafec078151018da7aaf3c941bd31f246f590bc34fa3fef29ce77a773db16a6
          )
  FetchContent_GetProperties(fetch_testing_data)
  if(NOT fetch_testing_data_POPULATED)
    set(FETCHCONTENT_QUIET OFF)
    FetchContent_Populate( fetch_testing_data )
  endif()
  endif()
endif()

#######################################################################
# Find unix math libraries
if(NOT WIN32)
    find_library(NIFTI_SYSTEM_MATH_LIB m)
else()
    set(NIFTI_SYSTEM_MATH_LIB "")
endif()
#######################################################################
add_subdirectory(znzlib)
add_subdirectory(niftilib)

option(USE_NIFTICDF_CODE "Build nifticdf library and tools" ON)
mark_as_advanced(USE_NIFTICDF_CODE)
if(USE_NIFTICDF_CODE)
    add_subdirectory(nifticdf)
endif()

option(USE_NIFTI2_CODE "Build the nifti2 library and tools" ON)
mark_as_advanced(USE_NIFTI2_CODE)
cmake_dependent_option(USE_CIFTI_CODE "Build the cifti library and tools" OFF "USE_NIFTI2_CODE" OFF)
mark_as_advanced(USE_CIFTI_CODE)

if( USE_NIFTI2_CODE )
  add_subdirectory(nifti2)
  if( USE_CIFTI_CODE )
    add_subdirectory(cifti)
  endif()
endif()

option(USE_FSL_CODE "If OFF, The copyright of this code is questionable for inclusion with nifti." OFF)
mark_as_advanced(USE_FSL_CODE)
# the order of add_subdirectory is important! fsliolob has to preceed examples
# as otherwise FSLIOLIB_SOURCE_DIR is undefined and hence the examples
# will fail to compile
if(USE_FSL_CODE)
  add_subdirectory(fsliolib)
endif()

# Allow an uninstall (with some risk of messiness)

if(NOT TARGET uninstall)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY
  )

  add_custom_target(
    uninstall COMMAND ${CMAKE_COMMAND} -P
                      ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
  )
endif()

# Report installed targets
get_property(nifti_installed_targets GLOBAL PROPERTY nifti_installed_targets)
message("nifti_installed_targets: ${nifti_installed_targets}")

if(CMAKE_VER_AT_LEAST_3_13)
  # Target installation for CMake versions >=3.13
  foreach(targ ${nifti_installed_targets})
    install_nifti_target(${targ})
  endforeach()
endif()

if(NOT NIFTI_INSTALL_NO_DOCS)
  install(
      DIRECTORY ${MAN_DIR}/
      DESTINATION ${NIFTI_INSTALL_MAN_DIR}
      FILES_MATCHING REGEX ".*.1.gz"
      PERMISSIONS OWNER_READ WORLD_READ
      )
  install(
    FILES ${PROJECT_SOURCE_DIR}/README.md
    DESTINATION ${NIFTI_INSTALL_DOC_DIR}
    )
  install(
    DIRECTORY ${PROJECT_SOURCE_DIR}/real_easy/
    DESTINATION ${NIFTI_INSTALL_DOC_DIR}/examples
    )
endif()

if(NIFTI_INSTALL_EXPORT_NAME STREQUAL "NIFTITargets")
  #######################################################################
  # CMake itself and can use some CMake facilities for creating the package files.
  # This allows for find_package(NIFTI 2.1.0 NO_MODULE) to work for pulling in
  # NIFTI libraries into an external project
  include(CMakePackageConfigHelpers)
  set(CONFIG_SETUP_DIR ${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE_NAME})
  set(ConfigPackageLocation share/cmake/${PACKAGE_NAME})

  write_basic_package_version_file(
        ${CONFIG_SETUP_DIR}/${PACKAGE_NAME}ConfigVersion.cmake
        VERSION ${GIT_REPO_VERSION}
        COMPATIBILITY AnyNewerVersion
  )

  configure_file(cmake/NIFTIConfig.cmake
        ${CONFIG_SETUP_DIR}/${PACKAGE_NAME}Config.cmake
        COPYONLY
        )


  install(EXPORT ${NIFTI_INSTALL_EXPORT_NAME}
        FILE NIFTITargets.cmake
        NAMESPACE     ${PACKAGE_NAME}::
        DESTINATION   ${ConfigPackageLocation}
        COMPONENT     Development
        )

  install(FILES
           ${CONFIG_SETUP_DIR}/${PACKAGE_NAME}Config.cmake
           ${CONFIG_SETUP_DIR}/${PACKAGE_NAME}ConfigVersion.cmake
        COMPONENT     Development
        DESTINATION   ${ConfigPackageLocation}
  )
endif()

#######################################################################
## Add the cpack configuration settings last
option(NIFTI_USE_PACKAGING "Configure the packaging options for NIFTI" OFF)
mark_as_advanced(NIFTI_USE_PACKAGING)
if(NIFTI_USE_PACKAGING)
  include(cmake/NIFTICPackConfig.cmake)
endif()

=== Makefile ===

SHELL		=	csh

## Projects
NIFTI		=	niftilib
NIFTICDF	=	nifticdf
ZNZ		=	znzlib
FSLIO		=	fsliolib
TESTING		=	Testing
UTILS_PROGS	=	nifti_stats nifti_tool nifti1_test
THIS_DIR	=	`basename ${PWD}`

## Note the TARFILE_NAME embeds the release version number
TARFILE_NAME	=	nifticlib-2.0.0


## Compiler  defines
cc		=	gcc
CC		=	gcc
AR		=	ar
RANLIB  = ranlib
DEPENDFLAGS	=	-MM
GNU_ANSI_FLAGS	= 	-Wall -ansi -pedantic
ANSI_FLAGS	= 	${GNU_ANSI_FLAGS}
CFLAGS		=	$(ANSI_FLAGS)

## Command defines
## gmake does not work on MacOSX or some versions of linux MAKE  = gmake
RM		=	rm
MV		=	mv
CP		=	cp
TAR		=	/usr/local/pkg/gnu/bin/tar


## Installation
INSTALL_BIN_DIR	=	bin
INSTALL_LIB_DIR	=	lib
INSTALL_INC_DIR	=	include


## Zlib defines
ZLIB_INC	=	-I/usr/include
ZLIB_PATH	=	-L/usr/lib
ZLIB_LIBS 	= 	$(ZLIB_PATH) -lm -lz

##############################################################
# platform specific redefines (to use, set ARCH appropriately)

##ARCH = X86_64

ifeq ($(ARCH),SGI) ## SGI 32bit
ZLIB_INC	=	-I/usr/freeware/include
ZLIB_PATH	=	-L/usr/freeware/lib32
RANLIB		=	echo "ranlib not needed"
else
ifeq ($(ARCH),I386) ## 32-bit Linux
ZLIB_INC	=	-I/usr/include
ZLIB_PATH	=	-L/usr/lib
TAR		=	/bin/tar
else
ifeq ($(ARCH),X86_64) ## 64-bit Linux
ZLIB_INC	=
ZLIB_PATH	=
ZLIB_LIBS 	= 	$(ZLIB_PATH) -lm -lz
TAR		=	/bin/tar
endif
endif
endif


#################################################################

## ZNZ defines
ZNZ_INC		=	-I../$(ZNZ)
ZNZ_PATH	=	-L../$(ZNZ)
ZNZ_LIBS	=	$(ZNZ_PATH)  -lznz
USEZLIB         =       -DHAVE_ZLIB

## NIFTI defines
NIFTI_INC	=	-I../$(NIFTI)
NIFTI_PATH	=	-L../$(NIFTI)
NIFTI_LIBS	=	$(NIFTI_PATH) -lniftiio

## NIFTICDF defines
NIFTICDF_INC	=	-I../$(NIFTICDF)
NIFTICDF_PATH	=	-L../$(NIFTICDF)
NIFTICDF_LIBS	=	$(NIFTICDF_PATH) -lnifticdf

## FSLIO defines
FSLIO_INC	=	-I../$(FSLIO)
FSLIO_PATH	=	-L../$(FSLIO)
FSLIO_LIBS	=	$(FSLIO_PATH) -lfslio



## Rules

.SUFFIXES: .c .o

.c.o:
	$(CC) -c $(CFLAGS) $(INCFLAGS) $<

## Targets

all:	   znz nifti nifticdf fslio install mention_cmake

install:   znz_install nifti_install nifticdf_install fslio_install 

clean:	   znz_clean nifti_clean nifticdf_clean fslio_clean

clean_all: clean install_clean doc_clean


znz:
	echo "arch is $(ARCH)"
	(cd $(ZNZ); $(MAKE) depend; $(MAKE) lib;)
	@echo " ----------- $(ZNZ) build completed."
	@echo ""

nifti:	znz
	(cd $(NIFTI); $(MAKE) depend; $(MAKE) lib;)
	@echo " ----------- $(NIFTI) build completed."
	@echo ""

nifticdf:nifti
	(cd $(NIFTICDF); $(MAKE) depend; $(MAKE) lib;)
	@echo " ----------- $(NIFTICDF) build completed."
	@echo ""

fslio:	nifti
	(cd $(FSLIO); $(MAKE) depend; $(MAKE) lib;)
	@echo " ----------  $(FSLIO) build completed."
	@echo ""

example:nifti
	(cd $(EXAMPLES); $(MAKE) all;)
	@echo Example programs built.
	@echo ""


doc:
	(cd docs; doxygen Doxy_nifti.txt;)
	@echo "doxygen doc rebuilt, run netscape docs/html/index.html to view."
	@echo ""

$(INSTALL_BIN_DIR):
	mkdir -p $@

$(INSTALL_INC_DIR):
	mkdir -p $@

$(INSTALL_LIB_DIR):
	mkdir -p $@

znz_install: $(INSTALL_INC_DIR) $(INSTALL_LIB_DIR)
	($(CP) $(ZNZ)/*.a $(INSTALL_LIB_DIR); $(CP) $(ZNZ)/*.h $(INSTALL_INC_DIR);)
	$(RANLIB) $(INSTALL_LIB_DIR)/*.a
	@echo " $(ZNZ) installed."
	@echo ""

nifti_install: $(INSTALL_INC_DIR) $(INSTALL_LIB_DIR)
	($(CP) $(NIFTI)/*.a $(INSTALL_LIB_DIR); $(CP) $(NIFTI)/*.h $(INSTALL_INC_DIR);)
	$(RANLIB) $(INSTALL_LIB_DIR)/*.a
	@echo " $(NIFTI) installed."
	@echo ""

nifticdf_install: $(INSTALL_INC_DIR) $(INSTALL_LIB_DIR)
	($(CP) $(NIFTICDF)/*.a $(INSTALL_LIB_DIR); $(CP) $(NIFTICDF)/*.h $(INSTALL_INC_DIR);)
	$(RANLIB) $(INSTALL_LIB_DIR)/*.a
	@echo " $(NIFTI) installed."
	@echo ""

fslio_install: $(INSTALL_INC_DIR) $(INSTALL_LIB_DIR)
	($(CP) $(FSLIO)/*.a $(INSTALL_LIB_DIR); $(CP) $(FSLIO)/*.h $(INSTALL_INC_DIR);)
	$(RANLIB) $(INSTALL_LIB_DIR)/*.a
	@echo " $(FSLIO) installed."
	@echo ""

install_clean:
	($(RM) -f $(INSTALL_INC_DIR)/* $(INSTALL_LIB_DIR)/* $(INSTALL_BIN_DIR)/*;)

znz_clean:
	(cd $(ZNZ); $(RM) -f *.o *.a core; $(RM) -f depend.mk;)

nifti_clean:
	(cd $(NIFTI); $(RM) -f *.o *.a core; $(RM) -f depend.mk;)

nifticdf_clean:
	(cd $(NIFTICDF); $(RM) -f *.o *.a core; $(RM) -f depend.mk;)

fslio_clean:
	(cd $(FSLIO); $(RM) -f *.o *.a core; $(RM) -f depend.mk;)

doc_clean:
	($(RM) -fr docs/html;)

tar:
	(cd .. ; ln -s $(THIS_DIR) ${TARFILE_NAME} ; \
	$(TAR) --exclude=CVS -cf ${TARFILE_NAME}.tar ${TARFILE_NAME}/*; \
	rm -f ${TARFILE_NAME});
	@echo ''
	@echo 'tar file ../${TARFILE_NAME}.tar has been created.'
	@echo ''

mention_cmake:
	@echo ""
	@echo "---------------------------------------------------------"
	@echo "This packages has changed to rely more primarly on cmake,"
	@echo "and the Makefile system needs a little love."
	@echo ""
	@echo "Consider the steps for cmake, if they would be helpful:"
	@echo ""
	@echo "   mkdir cmake_build"
	@echo "   cd cmake_build"
	@echo "   cmake -DBUILD_SHARED_LIBS=ON .."
	@echo "   make"
	@echo ""

help:
	@echo ""
	@echo "all:           build and install znz, nifti1 and fslio libraries"
	@echo "install:       install znz, nifti1, and fslio libraries"
	@echo "doc:           build the doxygen docs for this project."
	@echo "               (Need doxygen installed, see"
	@echo "               http://www.stack.nl/~dimitri/doxygen/index.html"
	@echo "tar:           make a tar file of all nifti_io code, put in .."
	@echo ""
	@echo "clean:         remove .o .a etc. files from source directories"
	@echo "clean_all:     make clean and delete all installed files in bin,"
	@echo "               include and lib, and remove any autogenerated"
	@echo "               docs (docs/html)"
	@echo ""
	@echo "znz:              build the znz library"
	@echo "znz_install:      install the znz library"
	@echo "nifti:            build the nifti1 library"
	@echo "nifti_install:    install the nifti1 library"
	@echo "nifticdf:         build the nifti1 library"
	@echo "nifticdf_install: install the nifti1 library"
	@echo "fslio:            build the fslio library"
	@echo "fslio_install:    install the fslio library"
	@echo "example:          make the example program(s)"
	@echo ""

=== cifti/CMakeLists.txt ===
include(FindEXPAT)

set(NIFTI_CIFTILIB_NAME ${NIFTI_PACKAGE_PREFIX}cifti)

add_nifti_library(${NIFTI_CIFTILIB_NAME} afni_xml.c afni_xml_io.c )
set_target_properties(
  ${NIFTI_CIFTILIB_NAME}
  PROPERTIES
    PRIVATE_HEADER  "${CMAKE_CURRENT_LIST_DIR}/afni_xml.h;${CMAKE_CURRENT_LIST_DIR}/afni_xml_io.h"
    )
target_link_libraries( ${NIFTI_CIFTILIB_NAME} PUBLIC EXPAT::EXPAT ${NIFTI_PACKAGE_PREFIX}nifti2)
# Set lib version when buildung shared libs.
if(BUILD_SHARED_LIBS)
    set_target_properties(${NIFTI_CIFTILIB_NAME} PROPERTIES ${NIFTI_LIBRARY_PROPERTIES})
endif()
install_nifti_target(${NIFTI_CIFTILIB_NAME})


if(NIFTI_BUILD_APPLICATIONS)
  add_nifti_executable(${NIFTI_PACKAGE_PREFIX}afni_xml_tool afni_xml_tool.c)
  target_link_libraries(${NIFTI_PACKAGE_PREFIX}afni_xml_tool PUBLIC ${NIFTI_CIFTILIB_NAME})
  add_nifti_executable(${NIFTI_PACKAGE_PREFIX}cifti_tool cifti_tool.c)
  target_link_libraries(${NIFTI_PACKAGE_PREFIX}cifti_tool PUBLIC ${NIFTI_CIFTILIB_NAME})
  install_nifti_target(${NIFTI_PACKAGE_PREFIX}afni_xml_tool)
  install_nifti_target(${NIFTI_PACKAGE_PREFIX}cifti_tool)
endif()

=== cifti/Makefile ===

# note the TARFILE_NAME embeds the release version number
TARFILE_NAME	= nifti2clib-0.0.1

USEZLIB         = -DHAVE_ZLIB
N2DIR           = ../nifti2

## Compiler  defines
CC		= gcc -g
IFLAGS          = -I.
CFLAGS          = -Wall -std=gnu99 -pedantic
NIFLAGS         = $(IFLAGS) -I$(N2DIR) -I../niftilib -I../znzlib $(USEZLIB)

LLIBS 		= -lz -lm
OBJS            = afni_xml.o afni_xml_io.o
NOBJS           = nifti2_io.o nifticdf.o znzlib.o

# --------------------------------------------------
# default compile for C files
%.o : %.c %.h
	$(CC) -c $(CFLAGS) $(NIFLAGS) $< -o $@

# --------------------------------------------------
# main targets (primary is nifti_tool, for now)


afni_xml_tool: afni_xml_tool.c $(OBJS)
	$(CC) -o $@ $(CFLAGS) $(IFLAGS) $< $(OBJS) -lexpat $(LLIBS)

clean:
	$(RM) *.o afni_xml_tool cifti_tool

#afni_xml.o: afni_xml.c afni_xml.h
#	$(CC) -c $(CFLAGS) -I. $<

cifti_tool.o: cifti_tool.c
	$(CC) -c $(CFLAGS) $(NIFLAGS) $<

cifti_tool: $(OBJS) $(NOBJS) cifti_tool.o
	$(CC) -o $@ $(CFLAGS) $(NIFLAGS) \
              cifti_tool.o $(OBJS) $(NOBJS) -lexpat $(LLIBS)

# --------------------------------------------------
# targets from source residing elsewhere

nifti2_io.o:
	$(CC) -c -DHAVE_ZLIB $(CFLAGS) $(NIFLAGS) $(N2DIR)/nifti2_io.c

nifticdf.o:
	$(CC) -c -DHAVE_ZLIB $(CFLAGS) $(NIFLAGS) ../nifticdf/nifticdf.c

znzlib.o:
	$(CC) -c -DHAVE_ZLIB $(CFLAGS) $(NIFLAGS) ../znzlib/znzlib.c

=== fsliolib/CMakeLists.txt ===
# Michael Hanke 2004-04-25:
# Restructure the file to match those of niftilib and znzlib
set(NIFTI_FSLIOLIB_NAME ${NIFTI_PACKAGE_PREFIX}fslio)

add_nifti_library(${NIFTI_FSLIOLIB_NAME} fslio.c )
set_target_properties(
  ${NIFTI_FSLIOLIB_NAME}
  PROPERTIES
  PRIVATE_HEADER "${CMAKE_CURRENT_LIST_DIR}/fslio.h;${CMAKE_CURRENT_LIST_DIR}/dbh.h"
  )
target_link_libraries( ${NIFTI_FSLIOLIB_NAME} PUBLIC ${NIFTI_PACKAGE_PREFIX}niftiio)

# Set lib version when buildung shared libs.
if(BUILD_SHARED_LIBS)
  set_target_properties(${NIFTI_FSLIOLIB_NAME} PROPERTIES ${NIFTI_LIBRARY_PROPERTIES})
endif()

=== fsliolib/Makefile ===
include ../Makefile


PROJNAME = fslio

INCFLAGS = $(ZLIB_INC) $(ZNZ_INC) $(NIFTI_INC)
LIBS = $(ZLIB_LIBS) $(ZNZ_LIBS) $(NIFTI_LIBS) $(FSL_LIBS)

SRCS=fslio.c
OBJS=fslio.o

SCRIPTS = remove_ext fsloutputtype imtest imglob imcp imln imrm immv



depend:
	$(RM) -f depend.mk
	$(MAKE) depend.mk

depend.mk:
	$(CC) $(DEPENDFLAGS) $(INCFLAGS) $(SRCS) >> depend.mk

lib: libfslio.a

libfslio.a: ${OBJS}
	${AR} -r libfslio.a ${OBJS}


include depend.mk

=== nifti2/CMakeLists.txt ===
set(NIFTI_NIFTILIB2_NAME ${NIFTI_PACKAGE_PREFIX}nifti2)

add_nifti_library(${NIFTI_NIFTILIB2_NAME} nifti2_io.c )
target_link_libraries( ${NIFTI_NIFTILIB2_NAME} PUBLIC ${NIFTI_PACKAGE_PREFIX}znz ${NIFTI_SYSTEM_MATH_LIB})
set_target_properties(
  ${NIFTI_NIFTILIB2_NAME}
  PROPERTIES
    PUBLIC_HEADER
    "${CMAKE_CURRENT_LIST_DIR}/nifti1.h;${CMAKE_CURRENT_LIST_DIR}/nifti2.h;${CMAKE_CURRENT_LIST_DIR}/nifti2_io.h"
  )
# Set library version when building shared libs.
if(BUILD_SHARED_LIBS)
    get_lib_version_vars("nifti2_io_version.h" NIFTI2_VERSION NIFTI2_MAJOR_VERSION)
    set_target_properties(${NIFTI_NIFTILIB2_NAME}
      PROPERTIES
        ${NIFTI_LIBRARY_PROPERTIES}
        VERSION ${NIFTI2_VERSION}
        SOVERSION ${NIFTI2_MAJOR_VERSION}
        )
endif()
install_nifti_target(${NIFTI_NIFTILIB2_NAME})

if(NIFTI_BUILD_APPLICATIONS)
  set(NIFTI_TOOL ${NIFTI_PACKAGE_PREFIX}nifti_tool)
  add_nifti_executable(${NIFTI_TOOL} nifti_tool.c)
  target_link_libraries(${NIFTI_TOOL} PUBLIC ${NIFTI_NIFTILIB2_NAME})
  install_nifti_target(${NIFTI_TOOL})
  install_man_page(
      ${NIFTI_TOOL}
      OPTIONS_FOR_SECTIONS "-see_also"
      OPTS "--help-option=-help;--version-option=-ver_man;--no-info"
      )
endif()


if(NIFTI_BUILD_TESTING AND NIFTI_BUILD_APPLICATIONS)
  # in order to decouble nifti2 and niftilib, the nifti1.h file
  # is duplicated here.  The verify_nifti1_headers_are_same test
  # will fail if these two files are not identical.
  if( ( IS_DIRECTORY ${PROJECT_SOURCE_DIR}/nifti2 ) AND (IS_DIRECTORY ${PROJECT_SOURCE_DIR}/niftilib))
      message(STATUS "Testing same")
      add_test( NAME ${NIFTI_PACKAGE_PREFIX}verify_nifti1_headers_are_same COMMAND ${CMAKE_COMMAND} -E compare_files ${PROJECT_SOURCE_DIR}/nifti2/nifti1.h ${PROJECT_SOURCE_DIR}/niftilib/nifti1.h)
  endif()
  add_executable(${NIFTI_PACKAGE_PREFIX}clib_02_nifti2 clib_02_nifti2.c)
  target_link_libraries(${NIFTI_PACKAGE_PREFIX}clib_02_nifti2 PUBLIC ${NIFTI_NIFTILIB2_NAME})



  # Do all regression tests
  set(TOOL_SUFFIX "") # The suffxi used for this tool "1" for nifti1, and "" for nifti2
  set(TEST_PREFIX "${NIFTI_PACKAGE_PREFIX}nifti${TOOL_SUFFIX}")
  set(TOOL_NAME ${TEST_PREFIX}_tool)
  add_test( NAME ${TEST_PREFIX}_test_help COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti1_test>)
  add_test( NAME ${TEST_PREFIX}_test_n1   COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti1_test>  -n1 ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/ATestReferenceImageForReadingAndWriting.nii.gz ${CMAKE_CURRENT_BINARY_DIR}/n1 )
  add_test( NAME ${TEST_PREFIX}_test_n2   COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti1_test>  -n2 ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/ATestReferenceImageForReadingAndWriting.nii.gz ${CMAKE_CURRENT_BINARY_DIR}/n2 )
  add_test( NAME ${TEST_PREFIX}_test_a2   COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti1_test>  -a2 ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/ATestReferenceImageForReadingAndWriting.nii.gz ${CMAKE_CURRENT_BINARY_DIR}/a2 )
  add_test( NAME ${TEST_PREFIX}_test_zn1  COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti1_test> -zn1 ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/ATestReferenceImageForReadingAndWriting.nii.gz ${CMAKE_CURRENT_BINARY_DIR}/zn1 )
  add_test( NAME ${TEST_PREFIX}_test_zn2  COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti1_test> -zn2 ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/ATestReferenceImageForReadingAndWriting.nii.gz ${CMAKE_CURRENT_BINARY_DIR}/zn2 )
  add_test( NAME ${TEST_PREFIX}_test_za2  COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti1_test> -za2 ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/ATestReferenceImageForReadingAndWriting.nii.gz ${CMAKE_CURRENT_BINARY_DIR}/za2 )

  add_test( NAME ${TEST_PREFIX}_ver          COMMAND $<TARGET_FILE:${TOOL_NAME}> -nifti_ver)
  add_test( NAME ${TEST_PREFIX}_tool_ver     COMMAND $<TARGET_FILE:${TOOL_NAME}> -ver)
  add_test( NAME ${TEST_PREFIX}_help         COMMAND $<TARGET_FILE:${TOOL_NAME}> -help)
  add_test( NAME ${TEST_PREFIX}_nifti_hist   COMMAND $<TARGET_FILE:${TOOL_NAME}> -nifti_hist)
  add_test( NAME ${TEST_PREFIX}_hist         COMMAND $<TARGET_FILE:${TOOL_NAME}> -hist)

  add_test( NAME ${TEST_PREFIX}_disp_hdr     COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_hdr  -infiles ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/anat0.nii )
  add_test( NAME ${TEST_PREFIX}_disp_nim     COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_nim  -infiles ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/anat0.nii )
  add_test( NAME ${TEST_PREFIX}_disp_ext     COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_ext  -infiles ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/anat0.nii )
  add_test( NAME ${TEST_PREFIX}_header_check COMMAND $<TARGET_FILE:${TOOL_NAME}> -check_hdr -infiles ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/anat0.nii )
  add_test( NAME ${TEST_PREFIX}_nim_check    COMMAND $<TARGET_FILE:${TOOL_NAME}> -check_nim -infiles ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/anat0.nii )

  set_tests_properties(${TEST_PREFIX}_disp_hdr PROPERTIES LABELS NEEDS_DATA)
  set_tests_properties(${TEST_PREFIX}_disp_nim PROPERTIES LABELS NEEDS_DATA)
  set_tests_properties(${TEST_PREFIX}_disp_ext PROPERTIES LABELS NEEDS_DATA)
  set_tests_properties(${TEST_PREFIX}_header_check PROPERTIES LABELS NEEDS_DATA)
  set_tests_properties(${TEST_PREFIX}_nim_check PROPERTIES LABELS NEEDS_DATA)

  #The help screens always return 1; add_test( NAME ${NIFTI_PACKAGE_PREFIX}nifti1_tool1_help COMMAND $<TARGET_FILE:${TOOL_NAME}>)
  add_test( NAME ${TEST_PREFIX}_tool_n1  COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_hdr -infile ${CMAKE_CURRENT_BINARY_DIR}/n1 )
  add_test( NAME ${TEST_PREFIX}_tool_n2  COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_hdr -infile ${CMAKE_CURRENT_BINARY_DIR}/n2 )
  add_test( NAME ${TEST_PREFIX}_tool_a2  COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_hdr -infile ${CMAKE_CURRENT_BINARY_DIR}/a2 )
  add_test( NAME ${TEST_PREFIX}_tool_zn1 COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_hdr -infile ${CMAKE_CURRENT_BINARY_DIR}/zn1 )
  add_test( NAME ${TEST_PREFIX}_tool_zn2 COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_hdr -infile ${CMAKE_CURRENT_BINARY_DIR}/zn2 )
  add_test( NAME ${TEST_PREFIX}_tool_za2 COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_hdr -infile ${CMAKE_CURRENT_BINARY_DIR}/za2 )

  add_test( NAME ${TEST_PREFIX}_tool_diff_hdr         COMMAND $<TARGET_FILE:${TOOL_NAME}> -diff_hdr -infile ${CMAKE_CURRENT_BINARY_DIR}/zn1 ${CMAKE_CURRENT_BINARY_DIR}/zn1 )
  add_test( NAME ${TEST_PREFIX}_tool_diff_nims        COMMAND $<TARGET_FILE:${TOOL_NAME}> -diff_nim -infile ${CMAKE_CURRENT_BINARY_DIR}/zn1 ${CMAKE_CURRENT_BINARY_DIR}/zn1 )

  add_test( NAME ${TEST_PREFIX}_tool_copy_brick_list COMMAND $<TARGET_FILE:${TOOL_NAME}> -cbl -prefix cbl_zn1.nii -infile ${CMAKE_CURRENT_BINARY_DIR}/zn1.nii.gz[0,1])
  add_test( NAME ${TEST_PREFIX}_tool_disp_ci         COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_ci 2 2 2 -1 0 0 0  -infile ${CMAKE_CURRENT_BINARY_DIR}/zn1.nii.gz )

  add_test( NAME ${TEST_PREFIX}_tool_disp_ts         COMMAND $<TARGET_FILE:${TOOL_NAME}> -disp_ts 2 2 2 -infile ${CMAKE_CURRENT_BINARY_DIR}/zn1.nii.gz )
  add_test( NAME ${TEST_PREFIX}_tool_strip_extras    COMMAND $<TARGET_FILE:${TOOL_NAME}> -strip_extras -infile ${CMAKE_CURRENT_BINARY_DIR}/zn1.nii.gz )

  # This test needs a file that has extensions to remove
  #add_test( NAME ${TEST_PREFIX}_tool_rm_ext /bin/sh ${NIFTI_SOURCE_DIR}/niftilib/rmthenrun rm_ext.nii COMMAND $<TARGET_FILE:${TOOL_NAME}> -rm_ext ALL -prefix rm_ext.nii -infile ${CMAKE_CURRENT_BINARY_DIR}/zn1.nii.gz )
  add_test( NAME ${TEST_PREFIX}_tool_check_hdr COMMAND $<TARGET_FILE:${TOOL_NAME}> -check_hdr -infile ${CMAKE_CURRENT_BINARY_DIR}/za2 )
  add_test( NAME ${TEST_PREFIX}_tool_check_nim COMMAND $<TARGET_FILE:${TOOL_NAME}> -check_nim -infile ${CMAKE_CURRENT_BINARY_DIR}/za2 )
  set_tests_properties(${TEST_PREFIX}_tool_check_hdr PROPERTIES LABELS NEEDS_DATA)
  set_tests_properties(${TEST_PREFIX}_tool_check_nim PROPERTIES LABELS NEEDS_DATA)

  #add_test( NAME ${TEST_PREFIX}_tool_copy_collapsed_image /bin/sh ${NIFTI_SOURCE_DIR}/niftilib/rmthenrun cci_zn1.nii COMMAND $<TARGET_FILE:${TOOL_NAME}> -cci 2 2 2 -1 -1 -1 -1 -prefix cci_zn1.nii -infile ${CMAKE_CURRENT_BINARY_DIR}/zn1.nii.gz )

  add_test( NAME cleanup_n1  COMMAND ${CMAKE_COMMAND} -E remove -f ${CMAKE_CURRENT_BINARY_DIR}/n1.nii.gz  ${CMAKE_CURRENT_BINARY_DIR}/n1.nii )
  add_test( NAME cleanup_n2  COMMAND ${CMAKE_COMMAND} -E remove -f ${CMAKE_CURRENT_BINARY_DIR}/n2.nii     ${CMAKE_CURRENT_BINARY_DIR}/n2.hdr ${CMAKE_CURRENT_BINARY_DIR}/n2.img)
  add_test( NAME cleanup_a2  COMMAND ${CMAKE_COMMAND} -E remove -f ${CMAKE_CURRENT_BINARY_DIR}/a2.img     ${CMAKE_CURRENT_BINARY_DIR}/a2.hdr )
  add_test( NAME cleanup_zn1 COMMAND ${CMAKE_COMMAND} -E remove -f ${CMAKE_CURRENT_BINARY_DIR}/zn1.nii.gz ${CMAKE_CURRENT_BINARY_DIR}/cbl_zn1.nii )
  add_test( NAME cleanup_zn2 COMMAND ${CMAKE_COMMAND} -E remove -f ${CMAKE_CURRENT_BINARY_DIR}/zn2.img.gz ${CMAKE_CURRENT_BINARY_DIR}/zn2.hdr.gz )
  add_test( NAME cleanup_za2 COMMAND ${CMAKE_COMMAND} -E remove -f ${CMAKE_CURRENT_BINARY_DIR}/za2.img.gz ${CMAKE_CURRENT_BINARY_DIR}/za2.hdr.gz )

  # https://crascit.com/2016/10/18/test-fixtures-with-cmake-ctest/ as of cmake 3.7 fixtures are supported
  foreach( testsuffix "n1" "n2" "a2" "zn1" "zn2" "za2")
    #message(STATUS "Setting up ${testsuffix}")
    set_tests_properties( ${TEST_PREFIX}_tool_${testsuffix}
            PROPERTIES FIXTURES_REQUIRED NiftiTestGeneratedFiles_${testsuffix} )
    set_tests_properties( ${TEST_PREFIX}_test_${testsuffix}
            PROPERTIES FIXTURES_SETUP NiftiTestGeneratedFiles_${testsuffix})
      message(STATUS "NiftiTestGeneratedFiles_${testsuffix}" )
    set_tests_properties( ${TEST_PREFIX}_tool_${testsuffix} ${TEST_PREFIX}_test_${testsuffix}
            PROPERTIES RESOURCE_LOCK Serial_${testsuffix}
            LABELS NEEDS_DATA
            )
    set_tests_properties(cleanup_${testsuffix} PROPERTIES FIXTURES_CLEANUP  NiftiTestGeneratedFiles_${testsuffix} )
  endforeach()

  set_tests_properties( ${TEST_PREFIX}_tool_diff_hdr         PROPERTIES FIXTURES_REQUIRED NiftiTestGeneratedFiles_zn1)
  set_tests_properties( ${TEST_PREFIX}_tool_diff_nims        PROPERTIES FIXTURES_REQUIRED NiftiTestGeneratedFiles_zn1)
  set_tests_properties( ${TEST_PREFIX}_tool_copy_brick_list  PROPERTIES FIXTURES_REQUIRED NiftiTestGeneratedFiles_zn1)
  set_tests_properties( ${TEST_PREFIX}_tool_disp_ci          PROPERTIES FIXTURES_REQUIRED NiftiTestGeneratedFiles_zn1)
  set_tests_properties( ${TEST_PREFIX}_tool_disp_ts          PROPERTIES FIXTURES_REQUIRED NiftiTestGeneratedFiles_zn1)
  set_tests_properties( ${TEST_PREFIX}_tool_strip_extras     PROPERTIES FIXTURES_REQUIRED NiftiTestGeneratedFiles_zn1)
  set_tests_properties( ${TEST_PREFIX}_tool_check_hdr        PROPERTIES FIXTURES_REQUIRED NiftiTestGeneratedFiles_za2)
  set_tests_properties( ${TEST_PREFIX}_tool_check_nim        PROPERTIES FIXTURES_REQUIRED NiftiTestGeneratedFiles_za2)
  #set_tests_properties( ${TEST_PREFIX}_tool_copy_collapsed_image PROPERTIES FIXTURES_REQUIRED NiftiTestGeneratedFileszn1)

  set_tests_properties( ${TEST_PREFIX}_tool_diff_hdr ${TEST_PREFIX}_tool_diff_nims
          ${TEST_PREFIX}_tool_copy_brick_list
          ${TEST_PREFIX}_tool_disp_ci ${TEST_PREFIX}_tool_disp_ts ${TEST_PREFIX}_tool_strip_extras
          PROPERTIES RESOURCE_LOCK Serial_zn1
          LABELS NEEDS_DATA
          )
  #==END NIFTI1 and NIFTI2 common tests ============================================

  add_test( NAME ${TEST_PREFIX}_misc_tests COMMAND $<TARGET_FILE:${TOOL_NAME}> -run_misc_tests -debug 2 -infiles ${fetch_testing_data_SOURCE_DIR}/nifti_regress_data/e4.60005.nii.gz )
  set_tests_properties(${TEST_PREFIX}_misc_tests PROPERTIES LABELS NEEDS_DATA)
  if(UNIX AND NIFTI_SHELL_SCRIPT_TESTS) # unix needed to run shell scripts
      set(NIFTI_TEST_SCRIPT_DIR ${CMAKE_CURRENT_LIST_DIR}/nifti_regress_test/cmake_testscripts)

=== nifti2/Makefile ===

# note the TARFILE_NAME embeds the release version number
TARFILE_NAME	= nifti2clib-0.0.1

USEZLIB         = -DHAVE_ZLIB

## Compiler  defines
CC		= gcc
IFLAGS          = -I. -I../niftilib -I../znzlib
CFLAGS          = -Wall -std=gnu99 -pedantic $(USEZLIB) $(IFLAGS)

LLIBS 		= -lz -lm

MISC_OBJS	= nifticdf.o znzlib.o
OBJS	   	= nifti2_io.o $(MISC_OBJS)

TOOLS 	   	= nifti_tool nifti1_tool nifti2_tool
EXAMPLES   	= clib_02_nifti2


# --------------------------------------------------
# default compile for C files
%.o : %.c %.h
	$(CC) -c $(CFLAGS) $< -o $@

# --------------------------------------------------
# main targets (primary is nifti_tool, for now)

nifti_tool: nifti_tool.o nifti_tool.h nifti2objs
	$(CC) -o $@ $(CFLAGS) $< $(OBJS) $(LLIBS)

all: $(TOOLS) $(EXAMPLES)

clean:
	$(RM) *.o $(TOOLS) $(EXAMPLES)

nifti2objs: $(OBJS)

clib_02_nifti2: clib_02_nifti2.o nifti2objs
	$(CC) -o $@ $(CFLAGS) $< $(OBJS) $(LLIBS)

# --------------------------------------------------
# targets from source residing elsewhere
nifticdf.o:
	$(CC) -c $(CFLAGS) ../nifticdf/nifticdf.c -o $@

znzlib.o:
	$(CC) -c $(CFLAGS) ../znzlib/znzlib.c -o $@

# maybe we want to build NIFTI-1 nifti_tool
nifti1_tool: $(MISC_OBJS)
	$(CC) -o $@ -I../utils $(CFLAGS) \
	../niftilib/nifti_tool.c ../niftilib/nifti1_io.c $(MISC_OBJS) $(LLIBS)

# make non-clashing version
nifti2_tool: nifti_tool
	cp -p nifti_tool nifti2_tool

=== nifticdf/CMakeLists.txt ===
set(NIFTI_CDFLIB_NAME ${NIFTI_PACKAGE_PREFIX}nifticdf)

add_nifti_library(${NIFTI_CDFLIB_NAME} nifticdf.c )
set_target_properties(
  ${NIFTI_CDFLIB_NAME}
  PROPERTIES
    PUBLIC_HEADER
    "${CMAKE_CURRENT_LIST_DIR}/nifticdf.h"
  )
target_compile_options(${NIFTI_CDFLIB_NAME} PRIVATE "-D__COMPILE_UNUSED_FUNCTIONS__")
target_link_libraries(${NIFTI_CDFLIB_NAME} PUBLIC ${NIFTI_PACKAGE_PREFIX}niftiio)
get_lib_version_vars("nifticdf_version.h" NIFTICDF_VERSION NIFTICDF_MAJOR_VERSION)
if(BUILD_SHARED_LIBS)
    set_target_properties(${NIFTI_CDFLIB_NAME}
      PROPERTIES
        ${NIFTI_LIBRARY_PROPERTIES}
        VERSION ${NIFTICDF_VERSION}
        SOVERSION ${NIFTICDF_MAJOR_VERSION}
        )
endif()
install_nifti_target(${NIFTI_CDFLIB_NAME})
if(NIFTI_BUILD_APPLICATIONS)
  add_nifti_executable(${NIFTI_PACKAGE_PREFIX}nifti_stats nifti_stats.c)
  target_link_libraries( ${NIFTI_PACKAGE_PREFIX}nifti_stats PUBLIC ${NIFTI_PACKAGE_PREFIX}niftiio ${NIFTI_PACKAGE_PREFIX}nifticdf)
  install_nifti_target(${NIFTI_PACKAGE_PREFIX}nifti_stats)
  install_man_page(
    ${NIFTI_PACKAGE_PREFIX}nifti_stats
    OPTS "--help-option=-help;--version-string=${NIFTICDF_VERSION};--no-info"
              )
endif()


if(NIFTI_BUILD_TESTING AND NIFTI_BUILD_APPLICATIONS)
  foreach(DISTRIBUTION CORREL TTEST FTEST ZSCORE CHISQ BETA BINOM GAMMA POISSON NORMAL FTEST_NONC CHISQ_NONC LOGISTIC LAPLACE UNIFORM TTEST_NONC WEIBULL CHI INVGAUSS EXTVAL PVAL LOGPVAL LOG10PVAL )
    add_test( NAME ${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> 0:4:1 ${DISTRIBUTION})
    add_test( NAME q${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> -q 0:4:1 ${DISTRIBUTION})
    add_test( NAME q1${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> -q 0:4:1 ${DISTRIBUTION} 1 1 1)
    add_test( NAME d${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> -d 0:4:1 ${DISTRIBUTION})
    add_test( NAME d1${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> -d 0:4:1 ${DISTRIBUTION} 1 1 1)
    add_test( NAME 1${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> -1 0:4:1 ${DISTRIBUTION})
    add_test( NAME 11${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> -1 0:4:1 ${DISTRIBUTION} 1 1 1)
    add_test( NAME z${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> -z 0:4:1 ${DISTRIBUTION})
    add_test( NAME z1${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> -z 0:4:1 ${DISTRIBUTION} 1 1 1)
    add_test( NAME h${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> -h 0:4:1 ${DISTRIBUTION})
    add_test( NAME h1${NIFTI_PACKAGE_PREFIX}nifti_stats_${DISTRIBUTION}_test COMMAND $<TARGET_FILE:${NIFTI_PACKAGE_PREFIX}nifti_stats> -h 0:4:1 ${DISTRIBUTION} 1 1 1)
  endforeach()
endif()

=== nifticdf/Makefile ===
include ../Makefile

PROJNAME = nifticdflib

INCFLAGS = $(NIFTI_INC) $(NIFTICDF_INC)

SRCS=nifticdf.c
OBJS=nifticdf.o

depend:
	$(RM) -f depend.mk
	$(MAKE) depend.mk

depend.mk:
	$(CC) $(DEPENDFLAGS) $(INCFLAGS) $(SRCS) >> depend.mk

lib: libnifticdf.a

test: $(TESTXFILES)

nifticdf.o: nifticdf.c nifticdf.h
	$(CC) -c $(CFLAGS) $(USEZLIB) $(INCFLAGS) $<

libnifticdf.a: $(OBJS)
	$(AR) -r libnifticdf.a $(OBJS)
	$(RANLIB) $@

nifti_stats: nifti_stats.c
	$(CC) $(CFLAGS) -o nifti_stats nifti_stats.c $(NIFTI_INCS) $(ZNZ_INCS) $(NIFTICDF_LIBS) $(NIFTI_LIBS) $(ZNZ_LIBS)

include depend.mk

=== niftilib/Makefile ===
include ../Makefile

PROJNAME = niftiio

TAR     ?= /bin/tar
RM      ?= /bin/rm

INCFLAGS = $(ZLIB_INC) $(ZNZ_INC)
LIBS = $(ZLIB_LIBS) $(ZNZ_LIBS) $(NIFTI_LIBS)

SRCS=nifti1_io.c
OBJS=nifti1_io.o
MOBJS=mjtest.o

SCRIPTS =

depend:
	$(RM) -f depend.mk
	$(MAKE) depend.mk

depend.mk:
	$(CC) $(DEPENDFLAGS) $(INCFLAGS) $(SRCS) >> depend.mk

lib: libniftiio.a

nifti1_io.o: nifti1_io.c nifti1_io.h
	$(CC) -c $(CFLAGS) $(USEZLIB) $(INCFLAGS) $<

libniftiio.a: $(OBJS)
	$(AR) -r libniftiio.a $(OBJS)
	$(RANLIB) $@

nifti_tool: nifti_tool.c nifti_tool.h
	$(CC) $(CFLAGS) -Wall -o nifti_tool nifti_tool.c $(NIFTI_INCS) $(ZNZ_INCS) $(NIFTI_LIBS) $(ZNZ_LIBS)

nifti1_test: nifti1_test.c
	$(CC) $(CFLAGS) -o nifti1_test nifti1_test.c $(NIFTI_INCS) $(ZNZ_INCS) $(NIFTI_LIBS) $(ZNZ_LIBS)

# get the regression testing data tree
regress_data: nifti_regress_test/nifti_regress_data

# remove any result directories
regress_clean:
	$(RM) -fr nifti_regress_test/results*

# remove any result directories, and remove the data tree
regress_clean_all: regress_clean
	$(RM) -fr nifti_regress_test/nifti_regress_data

# download and unpack the regression data tree
nifti_regress_test/nifti_regress_data:
	wget http://nifti.nimh.nih.gov/pub/dist/data/nifti_regress_data.tgz
	( cd nifti_regress_test; $(TAR) -xzf ../nifti_regress_data.tgz; )
	$(RM) nifti_regress_data.tgz

include depend.mk

=== fsliolib/examples/CMakeLists.txt ===

add_executable(  ${NIFTI_PACKAGE_PREFIX}fsl_api_driver fsl_api_driver.c)
target_link_libraries( ${NIFTI_PACKAGE_PREFIX}fsl_api_driver PUBLIC ${NIFTI_PACKAGE_PREFIX}fslio)
target_include_directories(${NIFTI_PACKAGE_PREFIX}fsl_api_driver PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:${NIFTI_INSTALL_INCLUDE_DIR}>
        )

install(TARGETS ${NIFTI_PACKAGE_PREFIX}fsl_api_driver
        EXPORT ${NIFTI_INSTALL_EXPORT_NAME}
        RUNTIME DESTINATION ${NIFTI_INSTALL_RUNTIME_DIR} COMPONENT RuntimeLibraries
        LIBRARY DESTINATION ${NIFTI_INSTALL_LIBRARY_DIR} COMPONENT RuntimeLibraries
        ARCHIVE DESTINATION ${NIFTI_INSTALL_LIBRARY_DIR} COMPONENT Development
        INCLUDES DESTINATION ${NIFTI_INSTALL_INCLUDE_DIR}
        )

=== debian/changelog ===
nifticlib (3.0.1-9) unstable; urgency=medium

  * Team upload.
  * Add autopkgtests
  * Install examples
  * Bump Standards-Version to 4.6.1 (no changes needed)
  * Add copyright for test data

 -- Mohammed Bilal <mdbilal@disroot.org>  Tue, 31 May 2022 21:58:14 +0530

nifticlib (3.0.1-8) unstable; urgency=medium

  * Team upload.

  [ Juhani Numminen ]
  * Change Depends, Breaks, Provides, Conflicts and Replaces.
    - Remove references to libnifti0-dev, libnifti1-dev, libfslio-dev and
      libniftiio-dev (<= 3.0). They are not packages in any recent Debian
      release. Detected using 'cme check dpkg'.
    - libznz3, libnifti2-2: remove Breaks/Replaces against libnifti2
      (completely new sonames, no file conflicts).
    - libnifti2-2: Remove Provides: libnifti2. It cannot claim to provide the
      multiple libraries that libnifti2 has.
    - libnifticdf-dev: Remove erroneous Conflicts against libniftiio-dev.
    - libnifti2-dev, libniftiio-dev, libnifticdf-dev, libznz-dev:
      Add Breaks+Replaces libnifti-dev (<= 3.0) due to overwriting files.
    - libniftiio2, libnifticdf2:
      Add Breaks+Replaces libnifti2 (<= 3.0) due to having same sonames.
    - libnifti2-dev: Add Depends: libnifticdf-dev which was omitted.
    - libnifti2-dev: Make virtual provided libnifti-dev versioned
      (see: #978236).
  * Put transitional libnifti-dev in Section: oldlibs and nifti-bin in science.
  * d/rules: Change direct cmake to dh_auto_configure. This fixes handling of
    CPPFLAGS. Removed reference to -Wl,--as-needed, it is on by default.

  [ Michael R. Crusoe ]
  * Remove no-longer needed patches.
  * debian/control: apply the advice of the multi-arch hinter

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 02 Jan 2021 16:36:29 +0100

nifticlib (3.0.1-7) unstable; urgency=medium

  * Team upload.
  * d/control libnifti2-2 provides versioned libnifti2 (= 3.0.1)

 -- Antoni Villalonga <antoni@friki.cat>  Thu, 31 Dec 2020 03:42:09 +0100

nifticlib (3.0.1-6) unstable; urgency=medium

  * Team upload.
  * Source-only upload.

 -- Andreas Tille <tille@debian.org>  Fri, 25 Dec 2020 15:07:16 +0100

nifticlib (3.0.1-5) unstable; urgency=medium

  * Team upload.
  * Provide transitional package libnifti-dev to enable smooth migration.

 -- Andreas Tille <tille@debian.org>  Fri, 25 Dec 2020 14:32:51 +0100

nifticlib (3.0.1-4) unstable; urgency=medium

  * Remove remaining illegal Provides: libnifti-dev
  * Fix Provides for shared lib

 -- Andreas Tille <tille@debian.org>  Mon, 07 Dec 2020 16:09:58 +0100

nifticlib (3.0.1-3) unstable; urgency=medium

  * Team upload
  * libnifti2-dev: Depends: libniftiio-dev, libznz-dev
    (addresses reopened #968730)
  * Make sure devel packages are installing properly

 -- Andreas Tille <tille@debian.org>  Mon, 07 Dec 2020 15:10:57 +0100

nifticlib (3.0.1-2) unstable; urgency=medium

  * Team upload.
  * Source only upload

 -- Andreas Tille <tille@debian.org>  Fri, 04 Dec 2020 23:48:56 +0100

nifticlib (3.0.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
    Closes: #968730
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Make source package Section: science
  * Separate binary packages for libznz, libniftiio, libnifticdf

 -- Andreas Tille <tille@debian.org>  Tue, 01 Dec 2020 22:17:54 +0100

=== debian/control ===
Source: nifticlib
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael Hanke <mih@debian.org>,
           Yaroslav Halchenko <debian@onerussian.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs,
               cmake,
               zlib1g-dev,
               doxygen,
               python3,
               graphviz
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/nifticlib
Vcs-Git: https://salsa.debian.org/med-team/nifticlib.git
Homepage: https://github.com/NIFTI-Imaging/nifti_clib
Rules-Requires-Root: no

Package: libnifti2-2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: IO libraries for the NIfTI-1 data format
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package contains the shared library of libnifti.

Package: libnifti2-dev
Architecture: any
Section: libdevel
Depends: libnifti2-2 (= ${binary:Version}),
         libnifticdf-dev (= ${binary:Version}),
         libniftiio-dev (= ${binary:Version}),
         libznz-dev (= ${binary:Version}),
         ${misc:Depends}
Breaks: libnifti-dev (<= 3.0)
Provides: libnifti-dev (= ${binary:Version})
Replaces: libnifti-dev (<= 3.0)
Description: IO libraries for the NIfTI-1 data format (development)
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package provides the header files and static libraries of libnifti2.

Package: libnifti-dev
Architecture: all
Section: oldlibs
Depends: libnifti2-dev,
         ${misc:Depends}
Description: IO libraries for the NIfTI-1 data format (obsolete)
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This is a transitional dummy package.  It installs libnifti2-dev which
 should be used instead.

Package: libniftiio2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libnifti2 (<= 3.0)
Replaces: libnifti2 (<= 3.0)
Description: low-level IO libraries for the NIfTI-1 data format (niftiio)
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package contains the shared library of the low-level IO library niftiio.

Package: libniftiio-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libniftiio2 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libnifti-dev (<= 3.0)
Replaces: libnifti-dev (<= 3.0)
Description: development low-level IO libraries for the NIfTI-1 data format (niftiio)
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package provides the header files and static libraries of libniftiio.

Package: libnifticdf2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libnifti2 (<= 3.0)
Replaces: libnifti2 (<= 3.0)
Description: NIfTI functions to compute cumulative distributions
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package contains the shared library nifticdf that provides functions
 to compute cumulative distributions and their inverses.

Package: libnifticdf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnifticdf2 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libnifti-dev (<= 3.0)
Replaces: libnifti-dev (<= 3.0)
Description: NIfTI functions to compute cumulative distributions (development)
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package contains the header files and static libraries nifticdf that
 provides functions to compute cumulative distributions and their inverses.

Package: libznz3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: low-level IO library znzlib for the NIfTI-1 data format
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package contains the shared library low-level IO library znzlib.

Package: libznz-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libznz3 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libnifti-dev (<= 3.0)
Replaces: libnifti-dev (<= 3.0)
Description: low-level IO library znzlib for the NIfTI-1 data format
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package provides the header files and static libraries of znzlib.

Package: nifti-bin
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: tools shipped with the NIfTI library
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package provides the tools that are shipped with the library
 (nifti_tool, nifti_stats and nifti1_test).

Package: libnifti-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Description: NIfTI library API documentation
 Niftilib is a set of i/o libraries for reading and writing files in the
 NIfTI-1 data format. NIfTI-1 is a binary file format for storing medical
 image data, e.g. magnetic resonance image (MRI) and functional MRI (fMRI)
 brain images.
 .
 This package provides the library API reference documentation.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/NIFTI-Imaging/nifti_clib/tags .*/v?@ANY_VERSION@\.tar\.gz
